//=======================================================================================
//  USB_VCOM , ͬ USB 豸, Ҫ 
//=======================================================================================
#include  "USB_define.h"

#define  USB_VID		               0x0416
#define  USB_PID		               0x5011

#define  DESC_DEVICE               0x01                    // USBЭ鶨ļ
#define  DESC_CONFIG               0x02
#define  DESC_STRING               0x03
#define  DESC_INTERFACE            0x04
#define  DESC_ENDPOINT             0x05
#define  DESC_QUALIFIER            0x06
#define  DESC_OTHERSPEED           0x07
#define  DESC_HID                  0x21                    // HID Descriptor Type 
#define  DESC_HID_RPT              0x22                    // HID Report Type 

#define  LEN_DEVICE                18                      // USBЭ鶨豸
#define  LEN_CONFIG                9                       // 
#define	 LEN_INTERFACE             9                       // ӿ
#define	 LEN_ENDPOINT              7                       // ˵

#define  EP_INPUT                  0x80                    // ˵ֽ2"λ"
#define  EP_OUTPUT                 0x00

#define  EP_CTL                    0x00                    // ˵ֽ3Ķ˵
#define  EP_ISO                    0x01
#define  EP_BULK                   0x02                  
#define  EP_INT                    0x03

const unsigned char USB_DeviceDescriptor[] =               // ׼豸,18ֽ
{
	LEN_DEVICE,		            /* bLength         */          // , ׼ 18ֽ
	DESC_DEVICE,	            /* bDescriptorType */          // 豸: 0x01
	0x00, 0x02,		            /* bcdUSB          */          // USB汾,ʮ
	0x02,			                /* bDeviceClass    */          // 豸
	0x00,			                /* bDeviceSubClass */
	0x00,			                /* bDeviceProtocol */
	USB_EP0_PACKET_SIZE,	    /* bMaxPacketSize0 */	         // ˵0ֽ
	USB_VID & 0x00FF,
	(USB_VID & 0xFF00) >> 8,  /* idVendor */
	USB_PID & 0x00FF,
	(USB_PID & 0xFF00) >> 8,  /* idProduct */
	0x00, 0x03,		            /* bcdDevice          */ 
	0x00,			                /* iManufacture       */       // ַ, ֧־0
	0x02,			                /* iProduct           */       // Ʒ
	0x00,			                /* iSerialNumber      */       // кŴ
	0x01			                /* bNumConfigurations */       // ǰõ
};

const unsigned char USB_ConfigDescriptor[] =               // 
{
	LEN_CONFIG,		            /* bLength            */
	DESC_CONFIG,	            /* bDescriptorType    */
	0x43, 0x00,		            /* wTotalLength       */       // ܳ
	0x02,			                /* bNumInterfaces     */       // ӿڸ
	0x01,			                /* bConfigurationValue*/       // ñ
	0x00,			                /* iConfiguration     */       // ,֧д0
	0xE0,			                /* bmAttributes       */       // ,λ6=1Թ,λ5=1Զ̻,λ7д1,δ
	0x32,			                /* MaxPower           */       // , 12mA

	LEN_INTERFACE,	          /* bLength            */
	DESC_INTERFACE,	          /* bDescriptorType    */
	0x00,			                /* bInterfaceNumber   */       // ӿڱ
	0x00,			                /* bAlternateSetting  */       // ѡĽӿڱ(һӿжʱ)
	0x01,			                /* bNumEndpoints      */       // ӿڶ˵
	0x02,			                /* bInterfaceClass    */       // ӿ
	0x02,		                  /* bInterfaceSubClass */
	0x01,			                /* bInterfaceProtocol */
	0x00,			                /* iInterface         */       //,֧־д0

	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x00,           /* Header functional descriptor subtype */
    0x10, 0x01,     /* Communication device compliant to the communication spec. ver. 1.10 */
    
	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x01,           /* Call management functional descriptor */
    0x00,           /* BIT0: Whether device handle call management itself. */
                    /* BIT1: Whether device can send/receive call management information over a Data Class Interface 0 */
    0x01,           /* Interface number of data class interface optionally used for call management */

	/* Communication Class Specified INTERFACE descriptor */
    0x04,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x02,           /* Abstract control management funcational descriptor subtype */
    0x00,           /* bmCapabilities       */
    
	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* bLength              */
    0x24,           /* bDescriptorType: CS_INTERFACE descriptor type */
    0x06,           /* bDescriptorSubType   */
    0x00,           /* bMasterInterface     */
    0x01,           /* bSlaveInterface0     */
    
	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	              /* bLength          */
	DESC_ENDPOINT,	            /* bDescriptorType  */
	(EP_INPUT | INT_IN_EP_NUM), /* bEndpointAddress */   // , ˵ַΪ:INT_IN_EP_NUM
	EP_INT,		                  /* bmAttributes     */   // ж
	USB_PACKET_SIZE, 0x00,	    /* wMaxPacketSize   */   // С
	0x01,	                      /* bInterval        */   //  1ms(1ms, 125us)
			
	/* INTERFACE descriptor */
	LEN_INTERFACE,	/* bLength              */
	DESC_INTERFACE,	/* bDescriptorType      */
	0x01,			/* bInterfaceNumber     */
	0x00,			/* bAlternateSetting    */
	0x02,			/* bNumEndpoints        */
	0x0A,			/* bInterfaceClass      */
	0x00,			/* bInterfaceSubClass   */
	0x00,			/* bInterfaceProtocol   */
	0x00,			/* iInterface           */
			
	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	                /* bLength          */
	DESC_ENDPOINT,	              /* bDescriptorType  */
	(EP_INPUT | BULK_IN_EP_NUM),	/* bEndpointAddress */    //˵ַ:1, Bulk in
	EP_BULK,		                  /* bmAttributes     */
	USB_PACKET_SIZE, 0x00,	      /* wMaxPacketSize   */
	0x00,			                    /* bInterval        */

	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	                /* bLength          */
	DESC_ENDPOINT,	              /* bDescriptorType  */
	(EP_OUTPUT | BULK_OUT_EP_NUM),/* bEndpointAddress */     //˵ַ:2, Bulk out
	EP_BULK,		                  /* bmAttributes     */
	USB_PACKET_SIZE, 0x00,        /* wMaxPacketSize   */
	0x00,			                    /* bInterval        */
};
////ַ֧,ЩַͿԲ,ʡռ=============================
const unsigned char USB_StringLang[] =
{
	4,				                                               // 
	DESC_STRING,	                                           // :
	0x09, 0x04
};
const unsigned char USB_ProductStringDesc[] =              // ûװʱ,ʾ
{
	24,     	                                               // 
	DESC_STRING,                                             // :
	'N', 0, 
  'U', 0,	
  'C', 0,	
  '1', 0,	
  '2', 0,	
  '3', 0,	
  ' ', 0,	
  'V', 0,	
	'C', 0,	
  'O', 0,	
  'M', 0
};
